#!/usr/bin/haserl
content-type: text/html

<? 
# Copyright (C) 2005 Enzo Michelangeli - All rights reserved 
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>Check PSTN termination rates for installed providers</title>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf-8">
</head>

<body>

<h1>Check PSTN termination rates for installed providers</h1>
<p>Enter a phone number starting with the country code. 
It is possible to enter only its first few digits, but, if they
do not include at least country and area code, the quoted
rate may be incorrect!</p>
<p>The rates list will only show the rates charged by installed 
providers that have a route for the specified number.</p>
<form action="<? echo -n $SCRIPT_NAME ?>" method=POST>
Phone number (or its first few digits): 
+<input type="text" name="diallednumber" value="<? echo -n "$FORM_diallednumber" ?>">
<input type="submit" value="Check rates!"
</form>

<?if [ -n "$FORM_diallednumber" ] ?> 
	<?
		. /usr/lib/asterisk/agi-bin/LCDial.sh
		callednumber=$(echo "$FORM_diallednumber" \
		| sed -e 's![^0-9]!!g' \
		)

		confdir=$(echo "$CONFFILE"|sed -e "s!$(basename $CONFFILE)\$!!") # no dirname in OpenWRT :-(
		open_r 3 "$CONFFILE"
		found=false
		while read -r provider ratefile otherparams <&3 ; do
			case _$provider in
			_\;*|_)
				continue	# comment or empty
			;;
			esac

			find_bestmatch_cost "$confdir$ratefile" # <<<<<<<<<<<<<<<<<<
			case _$cost in
			_)
				continue
			;;
			esac
			if [ "$cost" -ge 999999 ]; then continue; fi

			found=true
			rate=$(echo "$cost" \
			| awk '{print ($1 / 1000)}' \
			)
			provtable="$provtable<tr><td>$provider</td><td>$rate</td><td>US cent/minute</td></tr>"
		done
		close_r 3

		if $found; then
			echo "<hr>The following providers have a route to $FORM_diallednumber":
			echo "<table>"
			echo $provtable
			echo "</table>"
		else
			echo "<hr>No provider has routes to $FORM_diallednumber"
		fi

		#country_lookup=$(wget -O - http://www.0xdecafbad.com/uploads/country.csv  \
		country_lookup=$(cat $confdir/country.csv  \
		| sed -e "s/\$/_$callednumber/; s/\([^,]\+\)[,]\([0-9]\+\)_\2[0-9]*/\2 \1/;/_/d" \
		| sort | tail -1)
		
		case _"$country_lookup" in
		_)
			echo "<hr>The number does not appear in the numbering plan."
		;;
		*)
			echo "<hr>Prefix: $country_lookup"
		;;
		esac	
		echo "<hr>"
	?>
	
	

	
<?fi?>


</body>
</html>
